<?php
/* Autor...:  */
/* Esquema.: SEG_UsuarioOpciones.xml */
/* Generado: 2025-09-19 09:29:05 */

/* Metodos de acceso a los campos de la tabla SEG_UsuarioOpciones */
abstract class BaseSEG_UsuarioOpcionesBN
{
    /* Campos de la tabla */
    private $s_IdUsuario;    // IdUsuario: ( no definido )
    private $i_IdCompania;    // IdCompania: ( no definido )
    private $i_FlagImpresion;    // FlagImpresion: ( no definido )
    private $s_Estado;    // Estado: ( no definido )
    private $d_FechaCreacion;    // FechaCreacion: ( no definido )
    private $s_UsuarioCreacion;    // UsuarioCreacion: ( no definido )
    private $d_FechaModificacion;    // FechaModificacion: ( no definido )
    private $s_UsuarioModificacion;    // UsuarioModificacion: ( no definido )

    /* Establece el valor del campo IdUsuario */
    public function setIdUsuario( $s_IdUsuario )
    {
        $this->s_IdUsuario = $s_IdUsuario;
    }

    /* Obtiene el valor del campo IdUsuario */
    public function getIdUsuario()
    {
        return $this->s_IdUsuario;
    }

    /* Establece el valor del campo IdCompania */
    public function setIdCompania( $i_IdCompania )
    {
        $this->i_IdCompania = $i_IdCompania;
    }

    /* Obtiene el valor del campo IdCompania */
    public function getIdCompania()
    {
        return $this->i_IdCompania;
    }

    /* Establece el valor del campo FlagImpresion */
    public function setFlagImpresion( $i_FlagImpresion )
    {
        $this->i_FlagImpresion = $i_FlagImpresion;
    }

    /* Obtiene el valor del campo FlagImpresion */
    public function getFlagImpresion()
    {
        return $this->i_FlagImpresion;
    }

    /* Establece el valor del campo Estado */
    public function setEstado( $s_Estado )
    {
        $this->s_Estado = $s_Estado;
    }

    /* Obtiene el valor del campo Estado */
    public function getEstado()
    {
        return $this->s_Estado;
    }

    /* Establece el valor del campo FechaCreacion */
    public function setFechaCreacion( $d_FechaCreacion )
    {
        $this->d_FechaCreacion = $d_FechaCreacion;
    }

    /* Obtiene el valor del campo FechaCreacion */
    public function getFechaCreacion()
    {
        return $this->d_FechaCreacion;
    }

    /* Establece el valor del campo UsuarioCreacion */
    public function setUsuarioCreacion( $s_UsuarioCreacion )
    {
        $this->s_UsuarioCreacion = $s_UsuarioCreacion;
    }

    /* Obtiene el valor del campo UsuarioCreacion */
    public function getUsuarioCreacion()
    {
        return $this->s_UsuarioCreacion;
    }

    /* Establece el valor del campo FechaModificacion */
    public function setFechaModificacion( $d_FechaModificacion )
    {
        $this->d_FechaModificacion = $d_FechaModificacion;
    }

    /* Obtiene el valor del campo FechaModificacion */
    public function getFechaModificacion()
    {
        return $this->d_FechaModificacion;
    }

    /* Establece el valor del campo UsuarioModificacion */
    public function setUsuarioModificacion( $s_UsuarioModificacion )
    {
        $this->s_UsuarioModificacion = $s_UsuarioModificacion;
    }

    /* Obtiene el valor del campo UsuarioModificacion */
    public function getUsuarioModificacion()
    {
        return $this->s_UsuarioModificacion;
    }

    public function getJsonSerialize()
    {
        return 
        [
            'IdUsuario' => $this->getIdUsuario(),
            'IdCompania' => $this->getIdCompania(),
            'FlagImpresion' => $this->getFlagImpresion(),
            'Estado' => $this->getEstado(),
            'FechaCreacion' => $this->getFechaCreacion(),
            'UsuarioCreacion' => $this->getUsuarioCreacion(),
            'FechaModificacion' => $this->getFechaModificacion(),
            'UsuarioModificacion' => $this->getUsuarioModificacion(),
        ];
    }

    public function toArray()
    {
        return $this->processArray( get_object_vars( $this ) ); 
    }

    private function processArray( $array )
    {
        foreach( $array as $key => $value ) 
        {
            if ( is_object( $value ) )
            {
                $array[$key] = $value->toArray();
            }
            if ( is_array( $value ) ) 
            {
                $array[$key] = $this->processArray( $value );
            }
        }
        return $array;
    }

    public function __toString()
    {
        return json_encode( $this->toArray() ); 
    }

    /* Recupera un objeto SEG_UsuarioOpcionesBN desde un RecordSet */
    public static function retrieveByRs( $o_SEG_UsuarioOpcionesRs )
    {
        $o_SEG_UsuarioOpcionesBN = new SEG_UsuarioOpcionesBN();
        $o_SEG_UsuarioOpcionesBN->setIdUsuario( $o_SEG_UsuarioOpcionesRs[ "IdUsuario" ] );
        $o_SEG_UsuarioOpcionesBN->setIdCompania( ( integer ) $o_SEG_UsuarioOpcionesRs[ "IdCompania" ] );
        $o_SEG_UsuarioOpcionesBN->setFlagImpresion( ( integer ) $o_SEG_UsuarioOpcionesRs[ "FlagImpresion" ] );
        $o_SEG_UsuarioOpcionesBN->setEstado( $o_SEG_UsuarioOpcionesRs[ "Estado" ] );
        $o_SEG_UsuarioOpcionesBN->setFechaCreacion( utilTimestamp::getTimestamp( $o_SEG_UsuarioOpcionesRs[ "FechaCreacion" ], "Y-m-d H:i:s" ) );
        $o_SEG_UsuarioOpcionesBN->setUsuarioCreacion( $o_SEG_UsuarioOpcionesRs[ "UsuarioCreacion" ] );
        $o_SEG_UsuarioOpcionesBN->setFechaModificacion( utilTimestamp::getTimestamp( $o_SEG_UsuarioOpcionesRs[ "FechaModificacion" ], "Y-m-d H:i:s" ) );
        $o_SEG_UsuarioOpcionesBN->setUsuarioModificacion( $o_SEG_UsuarioOpcionesRs[ "UsuarioModificacion" ] );
        return $o_SEG_UsuarioOpcionesBN;
    }
}
?>